//----------------------------------------------------------------------------//
//                                         888                                //
//                                         888                                //
//                                         888                                //
//                         8888b.  888d888 888  888                           //
//                            `88b 888P'   888 .88P                           //
//                        .d888888 888     888888K                            //
//                        888  888 888     888 `88b                           //
//                        `Y888888 888     888  888                           //
//                                                                            //
//                                                                            //
//  File      : sprite.mjs                                                    //
//  Project   : lissajous                                                     //
//  Date      : 15 Dec, 21                                                    //
//  License   : GPLv3                                                         //
//  Author    : stdmatt <stdmatt@pixelwizards.io>                             //
//  Copyright : stdmatt - 2021                                                //
//                                                                            //
//  Description :                                                             //
//                                                                            //
//---------------------------------------------------------------------------~//
//----------------------------------------------------------------------------//
// Imports                                                                    //
//----------------------------------------------------------------------------//
//------------------------------------------------------------------------------
import { RES } from "./res.mjs";


//----------------------------------------------------------------------------//
// Sprite                                                                     //
//----------------------------------------------------------------------------//
//------------------------------------------------------------------------------
export class Sprite
    extends PIXI.Sprite
{
    //------------------------------------------------------------------------//
    // Factory                                                                //
    //------------------------------------------------------------------------//
    //--------------------------------------------------------------------------
    static from_texture(texture)
    {
        const sprite = Sprite(texture);
        return sprite;
    }

    //--------------------------------------------------------------------------
    static from_texture_named(texture_name)
    {
        const texture = RES.get_texture(texture_name);
        const sprite  = new Sprite(texture);

        return sprite;
    }

    //--------------------------------------------------------------------------
    static from_blank_texture(width, height)
    {
        const sprite = new Sprite(PIXI.Texture.WHITE);
        if(width && height) {
            sprite.width  = width;
            sprite.height = height;
        }

        return sprite;
    }

    //--------------------------------------------------------------------------
    static from_canvas(canvas)
    {
        const texture = PIXI.Texture.from(canvas);
        const sprite  = new Sprite(texture);

        return sprite;
    }

    //------------------------------------------------------------------------//
    //                                                                        //
    //------------------------------------------------------------------------//
    //--------------------------------------------------------------------------
    constructor(texture)
    {
        super(texture);
    }
}